SystemOrganization addCategory: #LightsOut!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction contador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOCell methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 9/29/2012 20:28'!
contador
	^contador ! !

!LOCell methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 9/29/2012 20:29'!
contador: num
	contador := num! !

!LOCell methodsFor: 'initialization' stamp: 'AngelaMayhuaQuispe 9/29/2012 20:46'!
initialize 
	super initialize.
	contador := 0.
	self label: contador asString.
	self borderWidth: 2.
	bounds := 0@0 corner: 50@50.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff 
	! !

!LOCell methodsFor: 'accessing' stamp: 'Angel 9/21/2012 13:37'!
mouseAction: aBlock
	^mouseAction := aBlock ! !

!LOCell methodsFor: 'event handling' stamp: 'Angel 9/21/2012 13:40'!
mouseUp: anEvent
	mouseAction value ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 15:12'!
cellsPerSide
	"El numero de celdas a lo largo de cada lado del juego"
	^10! !

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 14:02'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'initialization' stamp: 'Angel 9/21/2012 15:25'!
newCellAt: i at: j
	"Crea una celda en la posicion (i,j) y agrega esto a mi  representacion de pantalla en la posicion apropiada.
	Responde la nueva celda"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j-1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'AngelaMayhuaQuispe 9/29/2012 20:41'!
toggleNeighboursOfCellAt: i at: j
	| celda cont |
	celda := cells at: i at: j.
	cont := celda contador .
 	celda contador: (cont + 1).
	celda label: celda contador asString.
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i > 2) ifTrue: [ (cells at: i - 2 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(i < (self cellsPerSide - 1)) ifTrue: [ (cells at: i + 2 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j > 2) ifTrue: [ (cells at: i at: j - 2) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
	(j < (self cellsPerSide - 1)) ifTrue: [ (cells at: i at: j + 2) toggleState]! !
